config/routes.rb
Rails.application.routes.draw do

  root 'car_rental#home'
  get 'sessions/new'
  get 'users/new'
  get '/help', to: 'car_rental#help'
  get '/about', to:'car_rental#about'
  get  '/signup',  to: 'users#new'
  post '/signup',  to: 'users#create'

  get  '/new_user',  to: 'users#newuser'
  post '/new_user',  to: 'users#createuser'

  get  '/new_admin',  to: 'users#newadmin'
  get  '/edit',  to: 'users#edit'
  post '/new_admin',  to: 'users#createadmin'

  get  '/new_superadmin',  to: 'users#newsuperadmin'
  post '/new_superadmin',  to: 'users#createsuperadmin'


  get  '/cars',  to: 'cars#index'
  post '/cars',  to: 'cars#create'

  get    '/login',   to: 'sessions#new'
  post   '/login',   to: 'sessions#create'
  delete '/logout',  to: 'sessions#destroy'
  get 'show_admin', to: 'users#show_admin', as: :show_admin, via: :all
  match '/users/newadmin', to: 'users#newadmin', as: :newadmin, via: :all

  get 'show_superadmin', to: 'users#show_superadmin', as: :show_superadmin, via: :all
  match '/users/newsuperadmin', to: 'users#newsuperadmin', as: :newsuperadmin, via: :all

  get '/bookings/:id/check_out', to: 'bookings#check_out', as: :check_out
  get '/bookings/:id/return', to: 'bookings#return', as: :return

  get 'email_notification/:id/:id1' => 'cars#email_notification' ,:as => 'email_notification'

  #match '/users/newuser', to: 'users#newuser', as: :new_user, via: :all
  resources :bookings
  #resources :users

  resources :users do
    resources :bookings
  end


  resources :cars do
    resources :bookings
  end

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
  #root 'users#index'
end

app/models/user.rb
class User < ApplicationRecord
  has_many :bookings, dependent: :destroy
  before_save { email.downcase! }
  validates :name, presence: true, length: { maximum: 50 }
  VALID_EMAIL_REGEX = /\A[\w+\-.]+@[a-z\d\-.]+\.[a-z]+\z/i
  validates :email, presence: true, length: { maximum: 255 },
            format: { with: VALID_EMAIL_REGEX },
            uniqueness: { case_sensitive: false }
  has_secure_password
  validates :password, presence: true, length: { minimum: 6 }, allow_nil: true

  # Returns the hash digest of the given string.
  def User.digest(string)
    cost = ActiveModel::SecurePassword.min_cost ? BCrypt::Engine::MIN_COST :
               BCrypt::Engine.cost
    BCrypt::Password.create(string, cost: cost)
  end
end

app/controllers/users_controller.rb
class UsersController < ApplicationController
  before_action :logged_in_user, only: [:index, :edit, :update, :destroy]
  before_action :set_user, only: [:show, :edit, :update, :destroy]

  # GET /users
  # GET /users.json
  def index
    @users = User.all
  end

  # GET /users/1
  # GET /users/1.json
  def show
    @user = User.find(params[:id])
  end

  def show_admin
    @users = User.all
  end

  def show_superadmin
    @users = User.all
  end
  # GET /users/new
  def new
    @user = User.new
  end

  # GET /users/1/edit
  def edit
    @user = User.find(params[:id])
  end

  # POST /users
  # POST /users.json
  def create
    @user = User.new(user_params)
    respond_to do |format|
      if @user.save
        log_in @user
        flash[:success] = "Welcome to the Car Rental App!"
        format.html { redirect_to @user}
        format.json { render :show, status: :created, location: @user }
      else
        format.html { render :new }
        format.json { render json: @user.errors, status: :unprocessable_entity }
      end
    end
  end

  def newuser
    @user = User.new
  end

  def newadmin
    @user = User.new
  end

  def newsuperadmin
    @user = User.new
  end

  def createuser
    @user = User.new(user_params)

    if @user.save
      redirect_to current_user, notice: 'User was successfully created.'
    else
      render :new,  notice: 'User was not created!'
    end
  end

  def createadmin
    @user = User.new(user_params)
    @user.user_type = 1
    if @user.save
      redirect_to current_user, notice: 'Admin was successfully created.'
    else
      render :new, notice: 'Admin was not created!'
    end
  end

  def createsuperadmin
    @user = User.new(user_params)
    @user.user_type = 0
    if @user.save
      redirect_to current_user, notice: 'Super Admin was successfully created.'
    else
      render :new, notice: 'Super Admin was not created!'
    end
  end

  # PATCH/PUT /users/1
  # PATCH/PUT /users/1.json
  def update
    @user = User.find(params[:id])
    respond_to do |format|
      if @user.update(user_params)
        flash[:success] = "Profile updated"
        format.html { redirect_to current_user}
        format.json { render :show, status: :ok, location: @user }
      else
        format.html { render :edit }
        format.json { render json: @user.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /users/1
  # DELETE /users/1.json
  def destroy
    if(@user.user_type > 0)
      if(@user.user_type == 2)
        @booking = Booking.where("user_id = ? AND status < 2", @user.id)
        if @booking.length > 0
          respond_to do |format|
            format.html { redirect_to users_path, notice: 'User has an active booking. Can not be deleted.' }
            #format.json { head :no_content }
          end
        else
          @user.destroy
          respond_to do |format|
            format.html { redirect_to users_path, notice: 'User was successfully deleted.' }
            format.json { head :no_content }
          end
        end
      else
        @user.destroy
        respond_to do |format|
          format.html { redirect_to show_admin_path, notice: 'Admin was successfully deleted.' }
          format.json { head :no_content }
        end
      end
    else
      format.html { redirect_to :back, notice: 'Super Admin cannot be deleted.' }
    end
  end


    # Use callbacks to share common setup or constraints between actions.
  def set_user
    if(params[:id] == nil)
      @user = current_user
    else
      @user = User.find(params[:id])
    end
  end

    # Never trust parameters from the scary internet, only allow the white list through.

    def user_params
      params.require(:user).permit(:name, :email, :password, :password_confirmation)
    end

  # Confirms a logged-in user.
  def logged_in_user
    unless logged_in?
      store_location
      flash[:danger] = "Please log in."
      redirect_to login_url
    end
  end

  # Confirms the correct user.
  def correct_user
    @user = User.find(params[:id])
    redirect_to(root_url) unless current_user?(@user)
  end

  def type(val)
    if(val == 0)
      return 'Super Admin'
    elsif(val == 1)
      return 'Admin'
    else
      return 'User'
    end
  end
  helper_method :type

end

app/helpers/users_helper.rb
module UsersHelper
  # Returns the Gravatar for the given user.
  def gravatar_for(user, size: 80)
    gravatar_id = Digest::MD5::hexdigest(user.email.downcase)
    gravatar_url = "https://secure.gravatar.com/avatar/#{gravatar_id}?s=#{size}"
    image_tag(gravatar_url, alt: user.name, class: "gravatar")
  end
end

app/views/users/_form.html.erb
<%= form_with(model: user, local: true) do |form| %>
  <% if user.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(user.errors.count, "error") %> prohibited this user from being saved:</h2>

      <ul>
      <% user.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :name %>
    <%= form.text_field :name, id: :user_name %>
  </div>

  <div class="field">
    <%= form.label :email %>
    <%= form.text_field :email, id: :user_email %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/users/edit.html.erb
<%= link_to "Home", current_user, :method => :get %>
<% provide(:title, "Edit  user") %>
<% if @user.user_type.in?([0,1]) %>
    <h1>Editing Admin</h1>
<% else %>
    <h1>Editing User</h1>
<% end %>

<div class="row">
  <div class="col-md-6 col-md-offset-3">
    <%= form_for(@user) do |f| %>
        <%= render 'shared/error_messages' %>

        <%= f.label :name %>
        <%= f.text_field :name, class: 'form-control' %>

        <%= f.label :email %>
        <%= f.email_field :email, class: 'form-control' %>

        <%= f.label :password %>
        <%= f.password_field :password, class: 'form-control' %>

        <%= f.label :password_confirmation, "Confirmation" %>
        <%= f.password_field :password_confirmation, class: 'form-control' %>

        <%= f.submit "Save changes", class: "btn btn-primary" %>
    <% end %>

    <div class="gravatar_edit">
      <%= gravatar_for @user %>
      <a href="http://gravatar.com/emails" target="_blank">change</a>
    </div>
  </div>
</div>

app/views/users/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Users</h1>

<table>
  <thead>
    <tr>
      <th>Name</th>
      <th>Email</th>
      <th>User_type</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @users.each do |user| %>
      <% if user.user_type.in?([2]) %>
          <tr>
            <td><%= user.name %></td>
            <td><%= user.email %></td>
            <td><%= type(user.user_type) %></td>
            <td><%= link_to 'Bookings', user_bookings_path(user) %></td>
            <td><%= button_to 'Edit', edit_user_path(user), method: :get %></td>
            <td><%= button_to 'Delete', user, method: :delete, data: { confirm: 'Are you sure?' } %></td>
          </tr>
      <% end %>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'Create New User', new_user_path , {:style=>'color:blue;', :class => "css_class"}%>
<br><br>
<%= link_to 'Back to home page', current_user , {:style=>'color:green;', :class => "css_class"}%>

app/views/users/new.html.erb
<% provide(:title, 'Sign up') %>
<h1>Sign up</h1>

<div class="row">
  <div class="col-md-6 col-md-offset-3">
    <%= form_for(@user, url: signup_path) do |f| %>
        <%= render 'shared/error_messages' %>
        <%= f.label :name %>
        <%= f.text_field :name, class: 'form-control' %>

        <%= f.label :email %>
        <%= f.email_field :email, class: 'form-control' %>

        <%= f.label :password %>
        <%= f.password_field :password, class: 'form-control' %>

        <%= f.label :password_confirmation, "Confirmation" %>
        <%= f.password_field :password_confirmation, class: 'form-control' %>

        <%= f.submit "Create my account", class: "btn btn-primary" %>

        <%= link_to 'Back', root_path %>
    <% end %>
  </div>
</div>

app/views/users/newadmin.html.erb
<% provide(:title, 'Add Admin') %>
<h1>Add Admin</h1>

<div class="row">
  <div class="col-md-6 col-md-offset-3">
    <%= form_for(@user, url: new_admin_url) do |f| %>
        <%= render 'shared/error_messages' %>
        <%= f.label :name %>
        <%= f.text_field :name, class: 'form-control' %>

        <%= f.label :email %>
        <%= f.email_field :email, class: 'form-control' %>

        <%= f.label :password %>
        <%= f.password_field :password, class: 'form-control' %>

        <%= f.label :password_confirmation, "Confirmation" %>
        <%= f.password_field :password_confirmation, class: 'form-control' %>

        <%= f.submit "Create Admin", class: "btn btn-primary" %>
    <% end %>
  </div>
</div>

<b>
  <br>
  <%= link_to 'Back', current_user %>
</b>

app/views/users/newsuperadmin.html.erb
<% provide(:title, 'Add Super Admin') %>
<h1>Add Super Admin</h1>

<div class="row">
  <div class="col-md-6 col-md-offset-3">
    <%= form_for(@user, url: new_superadmin_url) do |f| %>
        <%= render 'shared/error_messages' %>
        <%= f.label :name %>
        <%= f.text_field :name, class: 'form-control' %>

        <%= f.label :email %>
        <%= f.email_field :email, class: 'form-control' %>

        <%= f.label :password %>
        <%= f.password_field :password, class: 'form-control' %>

        <%= f.label :password_confirmation, "Confirmation" %>
        <%= f.password_field :password_confirmation, class: 'form-control' %>

        <%= f.submit "Create Super Admin", class: "btn btn-primary" %>
    <% end %>
  </div>
</div>

<b>
  <br>
  <%= link_to 'Back', current_user %>
</b>

app/views/users/newuser.html.erb
<% provide(:title, 'Add User') %>
<h1>Add User</h1>

<div class="row">
  <div class="col-md-6 col-md-offset-3">
    <%= form_for(@user, url: new_user_url) do |f| %>
        <%= render 'shared/error_messages' %>
        <%= f.label :name %>
        <%= f.text_field :name, class: 'form-control' %>

        <%= f.label :email %>
        <%= f.email_field :email, class: 'form-control' %>

        <%= f.label :password %>
        <%= f.password_field :password, class: 'form-control' %>

        <%= f.label :password_confirmation, "Confirmation" %>
        <%= f.password_field :password_confirmation, class: 'form-control' %>

        <%= f.submit "Create User", class: "btn btn-primary" %>
    <% end %>
  </div>
</div>

<b>
  <br>
  <%= link_to 'Back', current_user %>
</b>

app/views/users/show.html.erb
<p id="notice"><%= notice %></p>

<%= link_to "Home", current_user, :method => :get %>

<h1>Welcome <%= @user.name %></h1>




<h4>
  <%= link_to 'Edit Profile', edit_user_path(@user), {:style=>'color:blue;', :class => "css_class"} %>
  <br />
  <% if @user.user_type.in?([0]) %>
      <%= link_to 'Manage Super Admins', show_superadmin_path, {:style=>'color:blue;', :class => "css_class"} %><br>
  <% end %>
  <% if @user.user_type.in?([0, 1]) %>
      <%= link_to 'Manage Admins', show_admin_path, {:style=>'color:blue;', :class => "css_class"} %><br>
      <%= link_to 'Manage Users',  users_path, {:style=>'color:blue;', :class => "css_class"} %><br>
      <%= link_to 'Manage Cars', cars_path(), {:style=>'color:blue;', :class => "css_class"} %><br>
      <%= link_to 'Manage bookings', bookings_path(), {:style=>'color:blue;', :class => "css_class"} %>
      <br />
  <% else %>
      <%= link_to 'Rent a Car', cars_path(), {:style=>'color:blue;', :class => "css_class"} %><br>
      <%= link_to 'Manage Bookings', bookings_path(), {:style=>'color:blue;', :class => "css_class"} %>
  <% end %>
</h4>

<% provide(:title, @user.name) %>
<div class="row">
  <aside class="col-md-4">
    <section class="user_info">
      <h1>
        <%= gravatar_for @user %>
        <%= @user.name %>
      </h1>
    </section>
  </aside>
</div>

app/views/users/show_admin.html.erb
<p id="notice"><%= notice %></p>

<h1>Admins</h1>

<table>
  <thead>
  <tr>
    <th>Name</th>
    <th>Email</th>
    <th>User_type</th>
    <th colspan="3"></th>
  </tr>
  </thead>

  <tbody>
  <% @users.each do |user| %>
      <% if user.user_type.in?([1]) %>
          <tr>
            <td><%= user.name %></td>
            <td><%= user.email %></td>
            <td><%= type(user.user_type) %></td>
            <td><%= button_to 'Edit', edit_user_path(user), method: :get %></td>
            <% if user != current_user && user.user_type != 0 %>
                <td><%= button_to 'Delete', user, method: :delete, data: { confirm: 'Are you sure?' } %></td>
            <% end %>
          </tr>
      <% end %>
  <% end %>
  </tbody>
</table>

<br>

<%= link_to 'Create a New Admin', newadmin_path, {:style=>'color:blue;', :class => "css_class"}%>
<br><br>
<%= link_to 'Back to home page', current_user , {:style=>'color:green;', :class => "css_class"}%>

app/views/users/show_superadmin.html.erb
<p id="notice"><%= notice %></p>

<h1>Admins</h1>

<table>
  <thead>
  <tr>
    <th>Name</th>
    <th>Email</th>
    <th>User_type</th>
    <th colspan="3"></th>
  </tr>
  </thead>

  <tbody>
  <% @users.each do |user| %>
      <% if user.user_type.in?([0]) %>
          <tr>
            <td><%= user.name %></td>
            <td><%= user.email %></td>
            <td><%= type(user.user_type) %></td>
            <td><%= button_to 'Edit', edit_user_path(user), method: :get %></td>
            <% if user != current_user && user.user_type != 0 %>
                <td><%= button_to 'Delete', user, method: :delete, data: { confirm: 'Are you sure?' } %></td>
            <% end %>
          </tr>
      <% end %>
  <% end %>
  </tbody>
</table>

<br>

<%= link_to 'Create a New Super Admin', newsuperadmin_path, {:style=>'color:blue;', :class => "css_class"}%>
<br><br>
<%= link_to 'Back to home page', current_user , {:style=>'color:green;', :class => "css_class"}%>